// Register the proxy script
browser.proxy.register("proxy/proxy-script.js");

// Log any errors from the proxy script
browser.proxy.onProxyError.addListener(error => {
  console.error(`Proxy error: ${error.message}`);
});

var myCredentials = {
  username: "aliu+test@tunnelbear.com",
  password: "tunnel_bear"
};

var pendingRequests = [];

function provideCredentials(requestDetails) {
  console.log("========== onAuthRequired handler called ==========");
  // If we have seen this request before, then
  // assume our credentials were bad, and give up.
  if (pendingRequests.indexOf(requestDetails.requestId) != -1) {
    console.log("bad credentials for: " + requestDetails.requestId);
    return {cancel:true};
  }
  pendingRequests.push(requestDetails.requestId);
  console.log("providing credentials for: " + requestDetails.requestId);
  return { authCredentials: myCredentials };
}

// A request has completed.
// We can stop worrying about it.
function completed(requestDetails) {
  console.log("completed: " + requestDetails.requestId);
  var index = pendingRequests.indexOf(requestDetails.requestId);
  if (index > -1) {
    pendingRequests.splice(index, 1);
  }
}


// Set up listeners
const target = "<all_urls>";

browser.webRequest.onAuthRequired.addListener(
  provideCredentials,
  {urls: [target]},
  ["blocking"]);

browser.webRequest.onCompleted.addListener(
  completed,
  {urls: [target]}
);

browser.webRequest.onErrorOccurred.addListener(
  completed,
  {urls: [target]}
);
